<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Numbering Types and Symbols</TITLE>
<link href="suif1_51.html" rel=Next>
<link href="suif1_49.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_49.html">previous</A>, <A HREF="suif1_51.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC50" HREF="suif1_toc.html#TOC50">Numbering Types and Symbols</A></H2>
<P>
<A NAME="IDX320"></A>
<A NAME="IDX321"></A>
<A NAME="IDX322"></A>
<A NAME="IDX323"></A>

</P>
<P>
<A NAME="IDX324"></A>
<A NAME="IDX325"></A>
Every symbol and type is assigned an ID number that uniquely identifies
it within a particular context.  These ID numbers should be used to
refer to symbols and types in annotations that will be written to the
output files and in other situations where pointers to the symbol and
type nodes cannot be used.  The <CODE>sym_id</CODE> method retrieves the ID
number for a symbol, and the <CODE>type_id</CODE> method gets the number for a
type.

</P>
<P>
<A NAME="IDX326"></A>
For symbols and types within a procedure, the ID numbers are only unique
within that procedure.  Similarly, the ID numbers for symbols and types
in a file symbol table are only unique within that file.  Only in the
global symbol table are the ID numbers truly unique.  This is
implemented by dividing the ID numbers into three ranges.  Each range is
reserved for a particular level in the symbol table hierarchy.  To make
it easier to read an ID number, the <CODE>print_id_number</CODE> function
prints it as a character to identify the range (<SAMP>`g'</SAMP> for global,
<SAMP>`f'</SAMP> for file, <SAMP>`p'</SAMP> for procedure) combined with the offset of
the number within that range.

</P>
<P>
<A NAME="IDX327"></A>
<A NAME="IDX328"></A>
The symbol and type ID numbers cannot be assigned individually, but the
symbol tables provide methods to set them.  The <CODE>number_globals</CODE>
method is defined in the <CODE>global_symtab</CODE> class to number the
entries in global and file symbol tables, and the <CODE>number_locals</CODE>
method is defined in the <CODE>proc_symtab</CODE> class to number all of the
entries in the procedure symbol table and its descendents.  These
methods only assign ID numbers to symbols and types that do not already
have numbers.  These methods are called automatically before writing
things out to files, but they can also be called whenever you want to
assign numbers to new symbols and types.

</P>
<P>
<A NAME="IDX329"></A>
<A NAME="IDX330"></A>
The <CODE>clear_sym_id</CODE> symbol method and <CODE>clear_type_id</CODE> method
are provided to reset the ID numbers to zero manually, but as far as
the library itself is concerned, this is never necessary.  The library
automatically changes ID numbers when necessary, such as when moving
from one symbol table to another.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_49.html">previous</A>, <A HREF="suif1_51.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
